 /* serv2.c */
 /* server exa */
 /* make sure you have either defined. my linux is redhat as to this writing */

/* #define CYGWIN */
 #define LINUX

 #ifdef CYGWIN
 #include "cygwin/socket.h"
 #include "cygwin/in.h"
 #endif

 #ifdef LINUX
 #include "linux/socket.h"
 #include "linux/in.h"
 #include "linux/time.h"
 #endif

#include<string.h>

                       /* this is non-checked for now */
 #define INMAX 8*1024
 #define SERV_TCP_PORT 8200
 /*you may want to pick a high default port number on linux */

 int sockfd,newsockfd,clilen;
 struct sockaddr_in cli_addr, serv_addr;
 char inlin[INMAX], intmp[INMAX];
 struct timeval timeout;
 fd_set fdvar;
 int tcpip_port = SERV_TCP_PORT;

 int do_read()
 {
   int rr, n, i,j,k;

   if (intmp[0] == '\0' ) {
      n = INMAX;

      FD_ZERO(&fdvar);
      FD_SET(newsockfd, &fdvar);

      timeout.tv_sec = 0;
      timeout.tv_usec = 0;

      if (select(newsockfd+1,&fdvar,(fd_set *) 0,
         (fd_set *) 0, (struct timeval *) 0) <= 0) return(0);
      if (FD_ISSET(newsockfd,&fdvar)  == 0)
         { return(0); }
      rr = read(newsockfd,intmp,n);
      if (rr <= 0) {
         rr = 0;
      }
      intmp[rr] = '\0';
   }
   strcpy(inlin,intmp);
   /* return(rr); */
   i = 0;
   while ( intmp[i] != '\0' && intmp[i] != '\r' && intmp[i] != '\n' ) {
   /*   printf("-%c %d %d-\n",intmp[i],(int) intmp[i], i); */
      inlin[i] = intmp[i]; i++;
   }
   /* printf("---%c %d-\n",intmp[i],i); */
   if ( intmp[i] == '\r' || intmp[i] == '\n' ) {
      /* printf("newline %d, %s.",i,intmp); */
      inlin[i] = '\0';
      j = i;
      while ( intmp[i] != '\0' && (intmp[i] == '\r' || intmp[i] == '\n') ) {
        i++;
      }
      if (intmp[i] == '\0') {
         intmp[0] = '\0';
         return(j);
      }
      k = 0;
      while ( intmp[i] != '\0') {
        intmp[k] = intmp[i];
        i++; k++;
      }
      intmp[k] = '\0';
   }
   inlin[i] = '\0';
   return(j);
   
   /* return(rr); */
 }

 int do_write(b)
 char b[];
 {
   int rr;
   int n;
   n = strlen(b);
   rr = write(newsockfd,b,n);
   return(rr);
 }

 serv_main()
 {
   int status;

   if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0)) <0 ) {
      printf("Error: can't open socket.\n");
      exit(-1);
   }

   bzero( (char *) &serv_addr, sizeof(serv_addr) );
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
   serv_addr.sin_port = htons(tcpip_port);

   setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, (char *) &status,
                sizeof(status));

   if (bind(sockfd, (struct sockaddr *) &serv_addr,
    sizeof(serv_addr)) < 0) {
      printf("Error: cannot bind socket.\n");
      exit(-1);
   }

   printf("waiting for connection ...\n");
   listen(sockfd,5);

      clilen = sizeof(cli_addr);
      newsockfd = accept(sockfd,
         (struct sockaddr *) &cli_addr, &clilen);
      if (newsockfd < 0) {
         printf("Error opening new socket.\n");
         exit(-1);
      }
   FD_ZERO(&fdvar);
   FD_SET(newsockfd, &fdvar);
   timeout.tv_sec = 0;
   timeout.tv_usec = 0;

   inlin[0] = '\0';
   intmp[0] = '\0';
 }
